type CdnAssetType = 'theme' | 'grammar' | 'oniguruma';
type Cdn = string | ((type: CdnAssetType, id: string) => string);
export declare let CDN: Cdn;
/**
 * Sets the CDN from which the theme/lang of <shiki-textarea/> is fetched.
 *
 * Accepts as arguments
 * - url: string
 * - callback: (type: 'lang' | 'theme' | 'oniguruma', id: string) => string
 *
 * When given an url, this will be used to fetch
 * - `${cdn}/tm-themes/themes/${theme}.json` for the `themes`
 * - `${cdn}/tm-grammars/grammars/${grammar}.json` for the `grammars`
 * - `${cdn}/vscode-oniguruma/release/onig.wasm` for the `oniguruma` wasm-file
 *
 * When given a callback, the returned string will be used to fetch.
 */
export declare function setCDN(cdn: Cdn): void;
export declare function urlFromCDN(type: CdnAssetType, key: string): string;
export declare function fetchFromCDN(type: 'theme' | 'grammar', key: string): Promise<any>;
export {};
