import { Element, ElementAttributes } from '@lume/element';
import { Grammar, Theme } from './tm';

/**********************************************************************************/
/**********************************************************************************/
interface TmTextareaAttributes extends Omit<ElementAttributes<TmTextareaElement, 'grammar' | 'theme' | 'editable'>, 'onInput' | 'oninput'> {
    oninput?: (event: InputEvent & {
        currentTarget: TmTextareaElement;
    }) => any;
    onInput?: (event: InputEvent & {
        currentTarget: TmTextareaElement;
    }) => any;
    value: string;
}
declare module 'solid-js/jsx-runtime' {
    namespace JSX {
        interface IntrinsicElements {
            'tm-textarea': TmTextareaAttributes;
        }
    }
}
declare global {
    namespace JSX {
        interface IntrinsicElements {
            'tm-textarea': TmTextareaAttributes;
        }
    }
}
declare class TmTextareaElement extends Element {
    editable: boolean;
    grammar: Grammar;
    stylesheet: string;
    theme: Theme;
    value: string;
    template: () => import("@lume/element").JSX.Element;
}
export declare function register(): void;
export {};
