var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _handleInitialPropertyValuesIfAny, handleInitialPropertyValuesIfAny_fn, ____init___, _disposeTemplate, _styleRootNode, _defaultHostStyle, _id, _dynamicStyle, _setStyle, setStyle_fn, _cleanupStyle, cleanupStyle_fn;
import { render, createComponent } from "solid-js/web";
import { createSignal, createEffect, createRoot, getOwner, runWithOwner, onCleanup, $PROXY, untrack, getListener } from "solid-js";
import { createTmTextarea, css } from "./core.js";
function createStoppableEffect(fn) {
  const [running, setRunning] = createSignal(true);
  createEffect(() => running() && fn());
  return {
    stop: () => setRunning(false),
    resume: () => setRunning(true)
  };
}
function Effectful(Base) {
  var _effects, _createEffect1, createEffect1_fn, _stopEffects1, stopEffects1_fn, _owner, _dispose, _createEffect2, createEffect2_fn, _stopEffects2, stopEffects2_fn, _a2;
  return _a2 = class extends Base {
    constructor() {
      super(...arguments);
      // Method 1 //////////////////////////////////////////
      // Works fine when not in a parent context, or else currently leaks or has the above mentioned bug while a parent exists.
      __privateAdd(this, _createEffect1);
      __privateAdd(this, _stopEffects1);
      __privateAdd(this, _createEffect2);
      __privateAdd(this, _stopEffects2);
      __privateAdd(this, _effects, /* @__PURE__ */ new Set());
      // Method 2 //////////////////////////////////////////
      // Works, with nesting, no leaks.
      __privateAdd(this, _owner, null);
      __privateAdd(this, _dispose, null);
    }
    /**
     * Create a Solid.js effect. The difference from regular
     * `createEffect()` is that `this` tracks the effects created, so that
     * they can all be stopped with `this.stopEffects()`.
     *
     * Effects can also be stopped or resumed individually:
     *
     * ```js
     * const effect1 = this.createEffect(() => {...})
     * const effect2 = this.createEffect(() => {...})
     *
     * // ...later
     * effect1.stop()
     *
     * // ...later
     * effect1.resume()
     * ```
     */
    createEffect(fn) {
      __privateMethod(this, _createEffect2, createEffect2_fn).call(this, fn);
    }
    /**
     * Stop all of the effects that were created.
     */
    stopEffects() {
      __privateMethod(this, _stopEffects2, stopEffects2_fn).call(this);
    }
  }, _effects = new WeakMap(), _createEffect1 = new WeakSet(), createEffect1_fn = function(fn) {
    let effect = null;
    effect = createStoppableEffect(() => {
      if (effect)
        __privateGet(this, _effects).add(effect);
      createEffect(fn);
      onCleanup(() => __privateGet(this, _effects).delete(effect));
    });
    __privateGet(this, _effects).add(effect);
  }, _stopEffects1 = new WeakSet(), stopEffects1_fn = function() {
    for (const effect of __privateGet(this, _effects))
      effect.stop();
  }, _owner = new WeakMap(), _dispose = new WeakMap(), _createEffect2 = new WeakSet(), createEffect2_fn = function(fn) {
    if (!__privateGet(this, _owner)) {
      createRoot((dispose) => {
        __privateSet(this, _owner, getOwner());
        __privateSet(this, _dispose, dispose);
        __privateMethod(this, _createEffect2, createEffect2_fn).call(this, fn);
      });
    } else {
      let owner = getOwner();
      while (owner && owner !== __privateGet(this, _owner))
        owner = (owner == null ? void 0 : owner.owner) ?? null;
      if (owner === __privateGet(this, _owner))
        return createEffect(fn);
      runWithOwner(__privateGet(this, _owner), () => createEffect(fn));
    }
  }, _stopEffects2 = new WeakSet(), stopEffects2_fn = function() {
    var _a3;
    (_a3 = __privateGet(this, _dispose)) == null ? void 0 : _a3.call(this);
  }, _a2;
}
function getInheritedDescriptor(obj, key) {
  let currentProto = obj;
  let descriptor;
  while (currentProto) {
    descriptor = Object.getOwnPropertyDescriptor(currentProto, key);
    if (descriptor) {
      descriptor.owner = currentProto;
      return descriptor;
    }
    currentProto = currentProto.__proto__;
  }
  return void 0;
}
const signalifiedProps = /* @__PURE__ */ new WeakMap();
function signalify(obj, ...props) {
  const _props = props.length ? props : Object.keys(obj).concat(Object.getOwnPropertySymbols(obj));
  for (const prop of _props)
    createSignalAccessor$1(obj, prop);
  return obj;
}
let gotCreateSignalAccessor = false;
function getCreateSignalAccessor() {
  if (gotCreateSignalAccessor)
    throw new Error('Export "createSignalAccessor" is internal to classy-solid only.');
  gotCreateSignalAccessor = true;
  return createSignalAccessor$1;
}
const propsSetAtLeastOnce = /* @__PURE__ */ new WeakMap();
function __isPropSetAtLeastOnce(instance, prop) {
  var _a2;
  return !!((_a2 = propsSetAtLeastOnce.get(instance)) == null ? void 0 : _a2.has(prop));
}
function trackPropSetAtLeastOnce(instance, prop) {
  if (!propsSetAtLeastOnce.has(instance))
    propsSetAtLeastOnce.set(instance, /* @__PURE__ */ new Set());
  propsSetAtLeastOnce.get(instance).add(prop);
}
const isSignalGetter = /* @__PURE__ */ new WeakSet();
function createSignalAccessor$1(obj, prop, initialVal = untrack(() => obj[prop]), override = false) {
  var _a2;
  if (!override && ((_a2 = signalifiedProps.get(obj)) == null ? void 0 : _a2.has(prop)))
    return;
  const proxy = obj[$PROXY];
  if (proxy)
    return;
  let descriptor = getInheritedDescriptor(obj, prop);
  let originalGet;
  let originalSet;
  if (descriptor) {
    originalGet = descriptor.get;
    originalSet = descriptor.set;
    if (originalGet && isSignalGetter.has(originalGet))
      return;
    if (originalGet || originalSet) {
      if (!originalGet || !originalSet) {
        console.warn(`The \`@signal\` decorator was used on an accessor named "${prop.toString()}" which had a getter or a setter, but not both. Reactivity on accessors works only when accessors have both get and set. In this case the decorator does not do anything.`);
        return;
      }
      delete descriptor.get;
      delete descriptor.set;
    } else {
      initialVal = descriptor.value;
      if (!descriptor.writable) {
        console.warn(`The \`@signal\` decorator was used on a property named "${prop.toString()}" that is not writable. Reactivity is not enabled for non-writable properties.`);
        return;
      }
      delete descriptor.value;
      delete descriptor.writable;
    }
  }
  const s = createSignal(initialVal, {
    equals: false
  });
  descriptor = {
    configurable: true,
    enumerable: true,
    ...descriptor,
    get: originalGet ? function() {
      s[0]();
      return originalGet.call(this);
    } : function() {
      return s[0]();
    },
    set: originalSet ? function(newValue) {
      originalSet.call(this, newValue);
      trackPropSetAtLeastOnce(this, prop);
      if (typeof newValue === "function")
        s[1](() => newValue);
      else
        s[1](newValue);
    } : function(newValue) {
      trackPropSetAtLeastOnce(this, prop);
      if (typeof newValue === "function")
        s[1](() => newValue);
      else
        s[1](newValue);
    }
  };
  isSignalGetter.add(descriptor.get);
  Object.defineProperty(obj, prop, descriptor);
  if (!signalifiedProps.has(obj))
    signalifiedProps.set(obj, /* @__PURE__ */ new Set());
  signalifiedProps.get(obj).add(prop);
}
let propsToSignalify = /* @__PURE__ */ new Map();
let accessKey$1 = null;
function getKey() {
  if (accessKey$1)
    throw new Error("Attempted use of classy-solid internals.");
  accessKey$1 = Symbol();
  return accessKey$1;
}
function getPropsToSignalify(key) {
  if (key !== accessKey$1)
    throw new Error("Attempted use of classy-solid internals.");
  return propsToSignalify;
}
function resetPropsToSignalify(key) {
  if (key !== accessKey$1)
    throw new Error("Attempted use of classy-solid internals.");
  propsToSignalify = /* @__PURE__ */ new Map();
}
function isMemberDecorator(context) {
  return !!("private" in context);
}
function signal(_, context) {
  const {
    kind,
    name
  } = context;
  const props = propsToSignalify;
  if (isMemberDecorator(context)) {
    if (context.private)
      throw new Error("@signal is not supported on private fields yet.");
    if (context.static)
      throw new Error("@signal is not supported on static fields yet.");
  }
  if (kind === "field") {
    props.set(name, {
      initialValue: void 0
    });
    return function(initialValue) {
      props.get(name).initialValue = initialValue;
      return initialValue;
    };
  } else if (kind === "getter" || kind === "setter") {
    props.set(name, {
      initialValue: void 0
    });
  } else {
    throw new Error("The @signal decorator is only for use on fields, getters, and setters. Auto accessor support is coming next if there is demand for it.");
  }
  queueReactiveDecoratorChecker(props);
}
let checkerQueued = false;
function queueReactiveDecoratorChecker(props) {
  if (checkerQueued)
    return;
  checkerQueued = true;
  queueMicrotask(() => {
    checkerQueued = false;
    if (props === propsToSignalify) {
      throw new Error(
        // Array.from(map.keys()) instead of [...map.keys()] because it breaks in Oculus browser.
        `Stray @signal-decorated properties detected: ${Array.from(props.keys()).join(", ")}. Did you forget to use the \`@reactive\` decorator on a class that has properties decorated with \`@signal\`?`
      );
    }
  });
}
const accessKey = getKey();
const createSignalAccessor = getCreateSignalAccessor();
const hasOwnProperty = Object.prototype.hasOwnProperty;
function reactive(value, context) {
  if (typeof value !== "function" || context && context.kind !== "class")
    throw new TypeError("The @reactive decorator is only for use on classes.");
  const Class = value;
  const signalProps = getPropsToSignalify(accessKey);
  resetPropsToSignalify(accessKey);
  class ReactiveDecorator extends Class {
    constructor(...args) {
      let instance;
      if (getListener())
        untrack(() => instance = Reflect.construct(Class, args, new.target));
      else
        super(...args), instance = this;
      for (const [prop, {
        initialValue
      }] of signalProps) {
        if (!(hasOwnProperty.call(instance, prop) || hasOwnProperty.call(Class.prototype, prop))) {
          throw new Error(`Property "${prop.toString()}" not found on instance of class decorated with \`@reactive\`. Did you forget to use the \`@reactive\` decorator on one of your classes that has a "${prop.toString()}" property decorated with \`@signal\`?`);
        }
        const override = true;
        createSignalAccessor(instance, prop, initialValue, override);
      }
      return instance;
    }
  }
  return ReactiveDecorator;
}
var _a;
let ctor;
const HTMLElement = globalThis.HTMLElement ?? class HTMLElement2 {
  constructor() {
    throw new Error("@lume/element needs a DOM to operate with! If this code is running during server-side rendering, it means your app is trying to instantiate elements when it shouldn't be, and should be refactored to avoid doing that when no DOM is present.");
  }
};
class LumeElement extends Effectful(HTMLElement) {
  constructor() {
    super(...arguments);
    __privateAdd(this, _handleInitialPropertyValuesIfAny);
    __privateAdd(this, _setStyle);
    __privateAdd(this, _cleanupStyle);
    // This property MUST be defined before any other non-static non-declared
    // class properties so that the initializer runs before any other properties
    // are defined, in order to detect and handle instance properties that
    // already pre-exist from custom element pre-upgrade time.
    // TODO Should we handle initial attributes too?
    // @ts-expect-error unused
    __privateAdd(this, ____init___, __privateMethod(this, _handleInitialPropertyValuesIfAny, handleInitialPropertyValuesIfAny_fn).call(this));
    /**
     * When `true`, the custom element will have a `ShadowRoot`. Set to `false`
     * to not use a `ShadowRoot`. When `false`, styles will not be scoped via
     * the built-in `ShadowRoot` scoping mechanism, but by a much more simple
     * shared style sheet placed at the nearest root node, with `:host`
     * selectors converted to tag names.
     */
    __publicField(this, "hasShadow", true);
    __publicField(this, "__root", null);
    __privateAdd(this, _disposeTemplate, void 0);
    __privateAdd(this, _styleRootNode, null);
    __privateAdd(this, _defaultHostStyle, (hostSelector) => (
      /*css*/
      `${hostSelector} {
		display: block;
	}`
    ));
    __privateAdd(this, _id, _a.__elementId++);
    __privateAdd(this, _dynamicStyle, null);
  }
  /**
   * Define this class for the given element `name`, or using its default name
   * (`elementName`) if no `name` given. Defaults to using the global
   * `customElements` registry unless another registry is provided (for
   * example a ShadowRoot-scoped registry).
   *
   * If a `name` is given, then the class will be extended with an empty
   * subclass so that a new class is used for each new name, because otherwise
   * a CustomElementRegistry does not allow the same exact class to be used
   * more than once regardless of the name.
   *
   * @returns Returns the defined element class, which is only going to be a
   * different subclass of the class this is called on if passing in a custom
   * `name`, otherwise returns the same class this is called on.
   */
  static defineElement(name, registry = customElements) {
    if (!name) {
      name = this.elementName;
      if (registry.get(name)) {
        console.warn(`defineElement(): An element class was already defined for tag name ${name}.`);
        return this;
      }
      registry.define(name, this);
      return this;
    } else {
      if (registry.get(name)) {
        console.warn(`defineElement(): An element class was already defined for tag name ${name}.`);
        return this;
      } else {
        const Class = class extends this {
        };
        Class.elementName = name;
        registry.define(name, Class);
        return Class;
      }
    }
  }
  /**
   * Subclasses can override this to provide an alternate Node to render into
   * (f.e. a subclass can `return this` to render into itself instead of
   * making a root) regardless of the value of `hasShadow`.
   */
  get root() {
    if (!this.hasShadow)
      return this;
    if (this.__root)
      return this.__root;
    if (this.shadowRoot)
      return this.__root = this.shadowRoot;
    return this.__root = this.attachShadow({ mode: "open" });
  }
  set root(v) {
    if (!this.hasShadow)
      throw new Error("Can not set root, element.hasShadow is false.");
    if (this.__root || this.shadowRoot)
      throw new Error("Element root can only be set once if there is no ShadowRoot.");
    this.__root = v;
  }
  /**
   * Define which `Node` to append style sheets to when `hasShadow` is `true`.
   * Defaults to the `this.root`, which in turn defaults to the element's
   * `ShadowRoot`.  When `hasShadow` is `true`, an alternate `styleRoot` is
   * sometimes needed for styles to be appended elsewhere than the root. For
   * example, return some other `Node` within the root to append styles to.
   * This is ignored if `hasShadow` is `false`.
   *
   * This can be useful for fixing issues where the default append of a style
   * sheet into the `ShadowRoot` conflicts with how DOM is created in
   * `template` (f.e.  if the user's DOM creation in `template` clears the
   * `ShadowRoot` content, or etc, then we want to place the stylesheet
   * somewhere else).
   */
  get styleRoot() {
    return this.root;
  }
  attachShadow(options) {
    if (this.__root)
      console.warn("Element already has a root defined.");
    return this.__root = super.attachShadow(options);
  }
  connectedCallback() {
    const template = this.template;
    if (template)
      __privateSet(this, _disposeTemplate, render(typeof template === "function" ? template.bind(this) : () => template, this.root));
    __privateMethod(this, _setStyle, setStyle_fn).call(this);
  }
  disconnectedCallback() {
    var _a2;
    this.stopEffects();
    (_a2 = __privateGet(this, _disposeTemplate)) == null ? void 0 : _a2.call(this);
    __privateMethod(this, _cleanupStyle, cleanupStyle_fn).call(this);
  }
  // not used currently, but we'll leave this here so that child classes can
  // call super, and that way we can add an implementation later when needed.
  adoptedCallback() {
  }
}
_handleInitialPropertyValuesIfAny = new WeakSet();
handleInitialPropertyValuesIfAny_fn = function() {
  const preUpgradeKeys = Object.keys(this);
  this._preUpgradeValues = /* @__PURE__ */ new Map();
  for (const propName of preUpgradeKeys) {
    const descriptor = Object.getOwnPropertyDescriptor(this, propName);
    if ("value" in descriptor) {
      delete this[propName];
      this._preUpgradeValues.set(propName, descriptor.value);
      queueMicrotask(() => {
        const propSetAtLeastOnce = __isPropSetAtLeastOnce(this, propName);
        if (propSetAtLeastOnce)
          return;
        const inheritsProperty = propName in this.__proto__;
        if (inheritsProperty)
          this[propName] = descriptor.value;
      });
    }
  }
};
____init___ = new WeakMap();
_disposeTemplate = new WeakMap();
_styleRootNode = new WeakMap();
_defaultHostStyle = new WeakMap();
_id = new WeakMap();
_dynamicStyle = new WeakMap();
_setStyle = new WeakSet();
setStyle_fn = function() {
  ctor = this.constructor;
  const staticCSS = typeof ctor.css === "function" ? ctor.css = ctor.css() : ctor.css || "";
  const instanceCSS = typeof this.css === "function" ? this.css() : this.css || "";
  if (this.hasShadow) {
    const hostSelector = ":host";
    const staticStyle = document.createElement("style");
    staticStyle.innerHTML = `
				${__privateGet(this, _defaultHostStyle).call(this, hostSelector)}
				${staticCSS}
				${instanceCSS}
			`;
    this.styleRoot.appendChild(staticStyle);
  } else {
    const rootNode = this.getRootNode();
    __privateSet(this, _styleRootNode, rootNode === document ? document.head : rootNode);
    let refCountPerTagName = _a.__styleRootNodeRefCountPerTagName.get(__privateGet(this, _styleRootNode));
    if (!refCountPerTagName)
      _a.__styleRootNodeRefCountPerTagName.set(__privateGet(this, _styleRootNode), refCountPerTagName = {});
    const refCount = refCountPerTagName[this.tagName] || 0;
    refCountPerTagName[this.tagName] = refCount + 1;
    if (refCount === 0) {
      const hostSelector = this.tagName.toLowerCase();
      const staticStyle = document.createElement("style");
      staticStyle.innerHTML = `
					${__privateGet(this, _defaultHostStyle).call(this, hostSelector)}
					${staticCSS ? staticCSS.replaceAll(":host", hostSelector) : staticCSS}
				`;
      staticStyle.id = this.tagName.toLowerCase();
      __privateGet(this, _styleRootNode).appendChild(staticStyle);
    }
    if (instanceCSS) {
      const id = this.tagName.toLowerCase() + "-" + __privateGet(this, _id);
      this.setAttribute(id, "");
      const instanceStyle = __privateSet(this, _dynamicStyle, document.createElement("style"));
      instanceStyle.id = id;
      instanceStyle.innerHTML = instanceCSS.replaceAll(":host", `[${id}]`);
      const rootNode2 = this.getRootNode();
      __privateSet(this, _styleRootNode, rootNode2 === document ? document.head : rootNode2);
      __privateGet(this, _styleRootNode).appendChild(instanceStyle);
    }
  }
};
_cleanupStyle = new WeakSet();
cleanupStyle_fn = function() {
  do {
    if (this.hasShadow)
      break;
    const refCountPerTagName = _a.__styleRootNodeRefCountPerTagName.get(__privateGet(this, _styleRootNode));
    if (!refCountPerTagName)
      break;
    let refCount = refCountPerTagName[this.tagName];
    if (refCount === void 0)
      break;
    refCountPerTagName[this.tagName] = --refCount;
    if (refCount === 0) {
      delete refCountPerTagName[this.tagName];
      const style = __privateGet(this, _styleRootNode).querySelector("#" + this.tagName);
      style == null ? void 0 : style.remove();
    }
  } while (false);
  if (__privateGet(this, _dynamicStyle))
    __privateGet(this, _dynamicStyle).remove();
};
/**
 * The default tag name of the elements this class instantiates. When using
 * the `@element` decorator, this property will be set to the value defined
 * by the decorator.
 */
__publicField(LumeElement, "elementName", "");
/** Non-decorator users can use this to specify attributes, which automatically map to reactive properties. */
__publicField(LumeElement, "observedAttributes");
__publicField(LumeElement, "__styleRootNodeRefCountPerTagName", /* @__PURE__ */ new WeakMap());
__publicField(LumeElement, "__elementId", 0);
_a = LumeElement;
Symbol.metadata ?? (Symbol.metadata = Symbol.for("Symbol.metadata"));
function camelCaseToDash(str) {
  return str.replace(/([a-zA-Z])(?=[A-Z])/g, "$1-").toLowerCase();
}
function defineProp(obj, prop, value) {
  Object.defineProperty(obj, prop, {
    value,
    writable: true,
    configurable: true,
    enumerable: true
  });
}
const __classFinishers = [];
function attribute(handlerOrValue, context) {
  if (arguments.length === 2)
    return handleAttributeDecoration(handlerOrValue, context, void 0);
  const handler = handlerOrValue;
  return (value, context2) => handleAttributeDecoration(value, context2, handler);
}
function handleAttributeDecoration(value, context, attributeHandler = {}) {
  const { kind, name, private: isPrivate, static: isStatic, metadata } = context;
  const noSignal = Object.hasOwn(metadata, "noSignal") && metadata.noSignal || void 0;
  const useSignal = !(noSignal == null ? void 0 : noSignal.has(name));
  if (typeof name === "symbol")
    throw new Error("@attribute is not supported on symbol fields yet.");
  if (isPrivate)
    throw new Error("@attribute is not supported on private fields yet.");
  if (isStatic)
    throw new Error("@attribute is not supported on static fields.");
  __classFinishers.push((Class) => __setUpAttribute(Class, name, attributeHandler));
  if (kind === "field") {
    const signalInitializer = useSignal ? signal(value, context) : (v) => v;
    return function(initialValue) {
      initialValue = signalInitializer(initialValue);
      if (!("default" in attributeHandler))
        attributeHandler.default = initialValue;
      return initialValue;
    };
  } else if (kind === "getter" || kind === "setter") {
    if (useSignal)
      signal(value, context);
  } else {
    throw new Error("@attribute is only for use on fields, getters, and setters. Auto accessor support is coming next if there is demand for it.");
  }
  return void 0;
}
function __setUpAttribute(ctor2, propName, attributeHandler) {
  if (
    //
    !ctor2.observedAttributes || !ctor2.hasOwnProperty("observedAttributes")
  ) {
    const inheritedAttrs = ctor2.__proto__.observedAttributes;
    if (inheritedAttrs && !Array.isArray(inheritedAttrs)) {
      throw new TypeError("observedAttributes is in the wrong format. Did you forget to decorate your custom element class with the `@element` decorator?");
    }
    defineProp(ctor2, "observedAttributes", [...inheritedAttrs || []]);
  }
  if (!Array.isArray(ctor2.observedAttributes)) {
    throw new TypeError("observedAttributes is in the wrong format. Maybe you forgot to decorate your custom element class with the `@element` decorator.");
  }
  const attrName = camelCaseToDash(propName);
  if (!ctor2.observedAttributes.includes(attrName))
    ctor2.observedAttributes.push(attrName);
  mapAttributeToProp(ctor2.prototype, attrName, propName, attributeHandler);
}
function mapAttributeToProp(prototype, attr, prop, attributeHandler) {
  if (!prototype.__hasAttributeChangedCallback) {
    prototype.__hasAttributeChangedCallback = true;
    const originalAttrChanged = prototype.attributeChangedCallback;
    prototype.attributeChangedCallback = function(attr2, oldVal, newVal) {
      var _a2, _b;
      if (originalAttrChanged) {
        originalAttrChanged.call(this, attr2, oldVal, newVal);
      } else {
        (_b = (_a2 = prototype.__proto__) == null ? void 0 : _a2.attributeChangedCallback) == null ? void 0 : _b.call(this, attr2, oldVal, newVal);
      }
      const prop2 = this.__attributesToProps && this.__attributesToProps[attr2];
      if (prop2) {
        const handler = prop2.attributeHandler;
        this[prop2.name] = !handler ? newVal : newVal === null ? "default" in handler ? handler.default : null : handler.from ? handler.from(newVal) : newVal;
      }
    };
  }
  if (!prototype.hasOwnProperty("__attributesToProps")) {
    Object.defineProperty(prototype, "__attributesToProps", {
      value: {
        __proto__: prototype.__attributesToProps || Object.prototype
      }
    });
  }
  prototype.__attributesToProps[attr] = { name: prop, attributeHandler };
}
const toString = (str) => str;
attribute.string = () => ({ from: toString });
function stringAttribute(value, context) {
  return attribute(attribute.string())(value, context);
}
const toNumber = (str) => +str;
attribute.number = () => ({ from: toNumber });
const toBoolean = (str) => str !== "false";
attribute.boolean = () => ({ from: toBoolean });
function booleanAttribute(value, context) {
  return attribute(attribute.boolean())(value, context);
}
function element(tagNameOrClass, autoDefineOrContext) {
  let tagName = "";
  let autoDefine = true;
  {
    tagName = tagNameOrClass;
    return (Class, context) => {
      return applyElementDecoration(Class, context, tagName, autoDefine);
    };
  }
}
function applyElementDecoration(Class, context, tagName, autoDefine) {
  if (typeof Class !== "function" || context && context.kind !== "class")
    throw new Error("@element is only for use on classes.");
  const { metadata = {} } = context ?? {};
  const noSignal = Object.hasOwn(metadata, "noSignal") && metadata.noSignal || void 0;
  let Ctor = Class;
  const attrs = Ctor.observedAttributes;
  if (Ctor.hasOwnProperty("elementName"))
    tagName = Ctor.elementName || tagName;
  else
    Ctor.elementName = tagName;
  if (Array.isArray(attrs))
    ;
  else if (attrs && typeof attrs === "object") {
    Ctor.observedAttributes = void 0;
    for (const prop in attrs)
      __setUpAttribute(Ctor, prop, attrs[prop]);
  }
  Ctor = reactive(Ctor, context);
  class ElementDecorator extends Ctor {
    constructor(...args) {
      super(...args);
      untrack(() => {
        handlePreUpgradeValues(this);
        const propsToSignalify2 = [];
        const attrsToProps = (
          // @ts-expect-error private access
          ElementDecorator.prototype.__attributesToProps ?? {}
        );
        for (const propSpec of Object.values(attrsToProps)) {
          const prop = propSpec.name;
          const useSignal = !(noSignal == null ? void 0 : noSignal.has(prop));
          if (useSignal)
            propsToSignalify2.push(prop);
          const handler = propSpec.attributeHandler;
          if (handler && !("default" in handler))
            handler.default = this[prop];
        }
        if (propsToSignalify2.length)
          signalify(this, ...propsToSignalify2);
      });
    }
  }
  const classFinishers = [...__classFinishers];
  __classFinishers.length = 0;
  function finishClass() {
    var _a2, _b;
    for (const finisher of classFinishers)
      finisher(ElementDecorator);
    if (tagName && autoDefine)
      (_b = (_a2 = globalThis.window) == null ? void 0 : _a2.customElements) == null ? void 0 : _b.define(tagName, ElementDecorator);
  }
  if (context == null ? void 0 : context.addInitializer) {
    context.addInitializer(finishClass);
  } else {
    finishClass();
  }
  return ElementDecorator;
}
function handlePreUpgradeValues(self) {
  if (!(self instanceof LumeElement))
    return;
  for (const [key, value] of self._preUpgradeValues) {
    if (!(key in self))
      continue;
    self._preUpgradeValues.delete(key);
    const desc = Object.getOwnPropertyDescriptor(self, key);
    if (desc && "value" in desc) {
      delete self[key];
    }
    self[key] = value;
  }
}
const classnames = ["container", "code", "line", "character", "textarea"];
const cache = /* @__PURE__ */ new Map();
function sheet(text) {
  if (text instanceof CSSStyleSheet) {
    return text;
  }
  if (!cache.has(text)) {
    const stylesheet = new CSSStyleSheet();
    stylesheet.replace(text);
    cache.set(text, stylesheet);
  }
  return cache.get(text);
}
let _initClass, _classDecs, _init_editable, _init_grammar, _init_stylesheet, _init_theme, _init_value;
function _applyDecs(e, t, r, n, o, a) {
  function i(e2, t2, r2) {
    return function(n2, o2) {
      return r2 && r2(n2), e2[t2].call(n2, o2);
    };
  }
  function c(e2, t2) {
    for (var r2 = 0; r2 < e2.length; r2++)
      e2[r2].call(t2);
    return t2;
  }
  function s(e2, t2, r2, n2) {
    if ("function" != typeof e2 && (n2 || void 0 !== e2))
      throw new TypeError(t2 + " must " + (r2 || "be") + " a function" + (n2 ? "" : " or undefined"));
    return e2;
  }
  function applyDec(e2, t2, r2, n2, o2, a2, c2, u2, l2, f2, p2, d, h) {
    function m(e3) {
      if (!h(e3))
        throw new TypeError("Attempted to access private element on non-instance");
    }
    var y, v = t2[0], g = t2[3], b = !u2;
    if (!b) {
      r2 || Array.isArray(v) || (v = [v]);
      var w = {}, S = [], A = 3 === o2 ? "get" : 4 === o2 || d ? "set" : "value";
      f2 ? (p2 || d ? w = { get: _setFunctionName(function() {
        return g(this);
      }, n2, "get"), set: function(e3) {
        t2[4](this, e3);
      } } : w[A] = g, p2 || _setFunctionName(w[A], n2, 2 === o2 ? "" : A)) : p2 || (w = Object.getOwnPropertyDescriptor(e2, n2));
    }
    for (var P = e2, j = v.length - 1; j >= 0; j -= r2 ? 2 : 1) {
      var D = v[j], E = r2 ? v[j - 1] : void 0, I = {}, O = { kind: ["field", "accessor", "method", "getter", "setter", "class"][o2], name: n2, metadata: a2, addInitializer: (function(e3, t3) {
        if (e3.v)
          throw Error("attempted to call addInitializer after decoration was finished");
        s(t3, "An initializer", "be", true), c2.push(t3);
      }).bind(null, I) };
      try {
        if (b)
          (y = s(D.call(E, P, O), "class decorators", "return")) && (P = y);
        else {
          var k, F;
          O.static = l2, O.private = f2, f2 ? 2 === o2 ? k = function(e3) {
            return m(e3), w.value;
          } : (o2 < 4 && (k = i(w, "get", m)), 3 !== o2 && (F = i(w, "set", m))) : (k = function(e3) {
            return e3[n2];
          }, (o2 < 2 || 4 === o2) && (F = function(e3, t3) {
            e3[n2] = t3;
          }));
          var N = O.access = { has: f2 ? h.bind() : function(e3) {
            return n2 in e3;
          } };
          if (k && (N.get = k), F && (N.set = F), P = D.call(E, d ? { get: w.get, set: w.set } : w[A], O), d) {
            if ("object" == typeof P && P)
              (y = s(P.get, "accessor.get")) && (w.get = y), (y = s(P.set, "accessor.set")) && (w.set = y), (y = s(P.init, "accessor.init")) && S.push(y);
            else if (void 0 !== P)
              throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");
          } else
            s(P, (p2 ? "field" : "method") + " decorators", "return") && (p2 ? S.push(P) : w[A] = P);
        }
      } finally {
        I.v = true;
      }
    }
    return (p2 || d) && u2.push(function(e3, t3) {
      for (var r3 = S.length - 1; r3 >= 0; r3--)
        t3 = S[r3].call(e3, t3);
      return t3;
    }), p2 || b || (f2 ? d ? u2.push(i(w, "get"), i(w, "set")) : u2.push(2 === o2 ? w[A] : i.call.bind(w[A])) : Object.defineProperty(e2, n2, w)), P;
  }
  function u(e2, t2) {
    return Object.defineProperty(e2, Symbol.metadata || Symbol.for("Symbol.metadata"), { configurable: true, enumerable: true, value: t2 });
  }
  if (arguments.length >= 6)
    var l = a[Symbol.metadata || Symbol.for("Symbol.metadata")];
  var f = Object.create(null == l ? null : l), p = function(e2, t2, r2, n2) {
    var o2, a2, i2 = [], s2 = function(t3) {
      return _checkInRHS(t3) === e2;
    }, u2 = /* @__PURE__ */ new Map();
    function l2(e3) {
      e3 && i2.push(c.bind(null, e3));
    }
    for (var f2 = 0; f2 < t2.length; f2++) {
      var p2 = t2[f2];
      if (Array.isArray(p2)) {
        var d = p2[1], h = p2[2], m = p2.length > 3, y = 16 & d, v = !!(8 & d), g = 0 == (d &= 7), b = h + "/" + v;
        if (!g && !m) {
          var w = u2.get(b);
          if (true === w || 3 === w && 4 !== d || 4 === w && 3 !== d)
            throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: " + h);
          u2.set(b, !(d > 2) || d);
        }
        applyDec(v ? e2 : e2.prototype, p2, y, m ? "#" + h : _toPropertyKey(h), d, n2, v ? a2 = a2 || [] : o2 = o2 || [], i2, v, m, g, 1 === d, v && m ? s2 : r2);
      }
    }
    return l2(o2), l2(a2), i2;
  }(e, t, o, f);
  return r.length || u(e, f), { e: p, get c() {
    var t2 = [];
    return r.length && [u(applyDec(e, [r], n, e.name, 5, f, t2), f), c.bind(null, t2, e)];
  } };
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t)
    return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i)
      return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return String(t);
}
function _setFunctionName(e, t, n) {
  "symbol" == typeof t && (t = (t = t.description) ? "[" + t + "]" : "");
  try {
    Object.defineProperty(e, "name", { configurable: true, value: n ? n + " " + t : t });
  } catch (e2) {
  }
  return e;
}
function _checkInRHS(e) {
  if (Object(e) !== e)
    throw TypeError("right-hand side of 'in' should be an object, got " + (null !== e ? typeof e : "null"));
  return e;
}
const TmTextarea = createTmTextarea(Object.fromEntries(classnames.map((name) => [name, name])));
const TmTextareaStyleSheet = sheet(css);
_classDecs = [element("tm-textarea")];
let _TmTextareaElement;
const _TmTextareaElement2 = class _TmTextareaElement2 extends LumeElement {
  constructor() {
    super(...arguments);
    __publicField(this, "editable", _init_editable(this, true));
    __publicField(this, "grammar", _init_grammar(this, "tsx"));
    __publicField(this, "stylesheet", _init_stylesheet(this, ""));
    __publicField(this, "theme", _init_theme(this, "dark-plus"));
    __publicField(this, "value", _init_value(this, ""));
    __publicField(this, "template", () => {
      const _self$ = this;
      const adoptedStyleSheets = this.shadowRoot.adoptedStyleSheets;
      adoptedStyleSheets.push(TmTextareaStyleSheet);
      if (this.stylesheet) {
        adoptedStyleSheets.push(sheet(this.stylesheet));
      }
      return createComponent(TmTextarea, {
        get grammar() {
          return _self$.grammar;
        },
        get theme() {
          return _self$.theme;
        },
        get value() {
          return _self$.value;
        },
        get editable() {
          return _self$.editable;
        },
        onInput: (e) => _self$.value = e.currentTarget.value
      });
    });
  }
};
({
  e: [_init_editable, _init_grammar, _init_stylesheet, _init_theme, _init_value],
  c: [_TmTextareaElement, _initClass]
} = _applyDecs(_TmTextareaElement2, [[booleanAttribute, 0, "editable"], [stringAttribute, 0, "grammar"], [stringAttribute, 0, "stylesheet"], [stringAttribute, 0, "theme"], [stringAttribute, 0, "value"]], _classDecs, 0, void 0, LumeElement));
_initClass();
let TmTextareaElement = _TmTextareaElement2;
function register() {
  if (!customElements.get("tm-textarea")) {
    customElements.define("tm-textarea", _TmTextareaElement);
  }
}
export {
  register
};
